package net.wanji.opt.dto.strategy;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

/**
 * @author Kent HAN
 * @date 2023/2/27 11:31
 */
@NoArgsConstructor
@Data
@ApiModel(value = "AddOrUpdateSceneDTO", description = "策略管理-场景库-新增/修改场景")
public class AddOrUpdateSceneDTO {
    @ApiModelProperty(value = "场景ID（不传ID为新增，传ID为修改）",notes = "")
    private Integer id;
    @ApiModelProperty(value = "编号",required = true, notes = "")
    private String sceneCode;
    @ApiModelProperty(value = "场景名称",required = true, notes = "")
    private String sceneName;
    @ApiModelProperty(value = "应用对象 1路口；2干线；3区域",required = true,notes = "")
    private Integer secneTarget;
    @ApiModelProperty(value = "应用策略",required = true,notes = "")
    private List<StrategyListElement> strategyList;

    @NoArgsConstructor
    @Data
    public static class StrategyListElement {
        @ApiModelProperty(value = "策略ID",required = true,notes = "")
        private Integer id;
        @ApiModelProperty(value = "策略名称",required = true,notes = "")
        private String strategyName;
        @ApiModelProperty(value = "优先级",required = true,notes = "")
        private Integer priority;
        @ApiModelProperty(value = "优化方法",required = true,notes = "")
        private List<IdeaListElement> ideaList;

    }
    @NoArgsConstructor
    @Data
    public static class IdeaListElement {
        @ApiModelProperty(value = "方法ID",required = true,notes = "")
        private Integer id;
        @ApiModelProperty(value = "方法名称",required = true,notes = "")
        private String ideaName;
        @ApiModelProperty(value = "返回顺序",required = true,notes = "")
        private Integer order;
    }
}
